//
// average - average.cpp
//
#include        <iostream>
#include        <sys/types.h>
#include        <queue>
#ifdef WIN32
#include        <process.h>
#include        <windows.h>
#else
#include        <pthread.h>
#endif

using namespace std;

queue < int > data;

#ifdef WIN32
unsigned __stdcall addData(void *arg)
{
    for(int i=0; i<100; i++){
		Sleep(1);
        cout << '+' ;
        data.push(10000);
    }

	return(0);
}
#else
void *addData(void *arg)
{
    for(int i=0; i<100; i++){
		sleep(1);
        cout << '+' ;
        data.push(10000);
    }

	return(0);
}
#endif

int main(int argc, char * argv[])
{
    // construct data
    for (int i=0; i<1000; i++){
        int x = 10;
        if (i % 2==0)
            x = 11;
        data.push(x);
    }

#ifdef WIN32
    unsigned	dummy;
	uintptr_t thread_id =_beginthreadex(NULL, 0, addData, (void *)NULL, 0, &dummy);
	if(thread_id == 0){
		cout << "pthread_create error" << endl;
        return -1;
	}
#else
    pthread_t thread_id;
	int status = pthread_create(&thread_id, NULL, addData, (void *)NULL);
	if(status != 0){
		cout << "pthread_create error" << endl;
        return -1;
	}
#endif

    // calc Avarsge
    double total = 0.0;
    int count = 0;
    for ( ; data.empty() == false; ){
        total += (double) data.front();
        data.pop();
        count++;
        if ((count % 100)==0)
#ifdef WIN32
            Sleep(1);
#else
            sleep(1);
#endif
    }
    double avr = total/count;

    cout << "Total=" << total << endl;
    cout << "Count=" << count << endl;
    cout << "Average=" << avr << endl;

	return 0;
}
