//
// tbballoc - tbballoc.cpp
//
#include <iostream>
#include <vector>
#include <string>
//#include "tbb/task_scheduler_init.h"
#include "tbb/cache_aligned_allocator.h"
#include "tbb/scalable_allocator.h"

using namespace std;
using namespace tbb;

const int N_DATA = 50;

int main(int argc, char * argv[])
{
    //task_scheduler_init init;

    vector<int, scalable_allocator<int> > savector;
    vector<int, cache_aligned_allocator<int> > caavector;

    for (int i=0; i<N_DATA; i++) {
        savector.push_back(i);
        caavector.push_back(i+10);
    }

    // Output 
    vector <int, scalable_allocator<int> >::iterator iter;
    for (iter = savector.begin(); iter<savector.end(); iter++)
        cout << *iter << ", ";
    cout << endl;

    vector <int, cache_aligned_allocator<int> >::iterator iter2;
    for (iter2 = caavector.begin(); iter2<caavector.end(); iter2++)
        cout << *iter2 << ", ";
    cout << endl;

    return 0;
}
